// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDON_WIDGETSMM_CAPTION_H
#define _HILDON_WIDGETSMM_CAPTION_H

#include <glibmm.h>

/* $Id: caption.hg,v 1.10 2005/02/15 10:52:44 murrayc Exp $ */

/* caption.h
 *
 * Copyright (C) 1998-2005 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/eventbox.h>
#include <gtkmm/sizegroup.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonCaption HildonCaption;
typedef struct _HildonCaptionClass HildonCaptionClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class Caption_Class; } // namespace Hildon
namespace Hildon
{

/** @addtogroup hildon_widgetsmmEnums Enums and Flags */

/**
 * @ingroup hildon_widgetsmmEnums
 */
enum CaptionStatus
{
  CAPTION_OPTIONAL,
  CAPTION_MANDATORY
};

} // namespace Hildon


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Hildon::CaptionStatus> : public Glib::Value_Enum<Hildon::CaptionStatus>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{


/**
 *
 * @ingroup Widgets
 */

class Caption : public Gtk::EventBox
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Caption CppObjectType;
  typedef Caption_Class CppClassType;
  typedef HildonCaption BaseObjectType;
  typedef HildonCaptionClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Caption();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Caption_Class;
  static CppClassType caption_class_;

  // noncopyable
  Caption(const Caption&);
  Caption& operator=(const Caption&);

protected:
  explicit Caption(const Glib::ConstructParams& construct_params);
  explicit Caption(HildonCaption* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonCaption*       gobj()       { return reinterpret_cast<HildonCaption*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonCaption* gobj() const { return reinterpret_cast<HildonCaption*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

public:
  Caption(Gtk::SizeGroup& group, const Glib::ustring& value,
          Gtk::Widget& child, Gtk::Widget& icon,
          CaptionStatus flag = CAPTION_OPTIONAL);
  

  //Ignore deprecated functions:
  

  /** Query Hildon::Caption whether this captioned control is a mandatory one.
   * 
   *  @a Returns  : is this captioned control a mandatory one?
   */
  bool is_mandatory() const;

  
  /** Sets Hildon::Caption status.
   * @param flag One of the values from Hildon::CaptionStatus.
   */
  void set_status(CaptionStatus flag);

  
  /** Gets Hildon::Caption status.
   * 
   *  @a Returns  : one of the values from Hildon::CaptionStatus
   */
  CaptionStatus get_status() const;

//TODO: Is this really any Widget?
  
  /** Sets the icon to be used by this hildon_caption widget.
   * @param icon The Gtk::Image to use as the icon. 
   * calls gtk_widget_show on the icon if !GTK_WIDGET_VISIBLE(icon).
   */
  void set_icon_image(Gtk::Widget& icon);

  
  /** Gets icon of Hildon::Caption
   * 
   *  @a Returns  : the Gtk::Image that is being used as the icon by the
   * hildon_caption, or <tt>0</tt> if no icon is in use
   */
  Gtk::Widget* get_icon_image();
  
  /** Gets icon of Hildon::Caption
   * 
   *  @a Returns  : the Gtk::Image that is being used as the icon by the
   * hildon_caption, or <tt>0</tt> if no icon is in use
   */
  const Gtk::Widget* get_icon_image() const;

  
  /** Sets the label text that appears before the control.  
   * Separator character is added to the end of the label string. By default
   * the separator is ":".
   * @param label The text to use.
   */
  void set_label(const Glib::ustring& label);

  
  /** Gets label of Hildon::Caption
   * 
   *  @a Returns  : the text currently being used as the label of the caption
   * control. The string is owned by the label and the caller should never 
   * free or modify this value.
   */
  Glib::ustring get_label() const;

  
  /** Sets the separator character that appears after the label.  
   * The default seaparator character is ":"
   * separately.
   * @param separator The separator to use.
   */
  void set_separator(const Glib::ustring& separator);
  
  /** Gets separator string of Hildon::Caption
   * 
   *  @a Returns  : the text currently being used as the separator of the caption
   * control. The string is owned by the caption control and the caller should
   * never free or modify this value.
   */
  Glib::ustring get_separator() const;

  
  /** Sets the vertical alignment to be used for the
   * text part of the caption. Applications need to
   * align the child control themselves.
   * 
   * Since: 0.12.0
   * @param alignment New vertical alignment.
   */
  void set_label_alignment(float alignment);
  
  /** Gets current vertical alignment for the text part.
   * @return Vertical alignment
   * 
   * Since: 0.12.0.
   */
  float get_label_alignment() const;

  
  /** Sets child expandability.
   * @param expand <tt>bool</tt> to determine is the child expandable.
   */
  void set_child_expand(bool expand = true);
  
  /** Gets childs expandability.
   * 
   *  @a Returns  : wheter the child is expandable or not.
   */
  bool get_child_expand() const;

  //TODO: Fix declaration (bug #185): _WRAP_SIGNAL(void activate(), "activate") 

  /** Caption label.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_label() ;

/** Caption label.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_label() const;

  /** The icon shown on the caption area.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Gtk::Widget*> property_icon() ;

/** The icon shown on the caption area.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Gtk::Widget*> property_icon() const;

  /** Mandatory or optional status.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<CaptionStatus> property_status() ;

/** Mandatory or optional status.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<CaptionStatus> property_status() const;

  /** Current separator.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_separator() ;

/** Current separator.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_separator() const;

  /** Current size group the caption is in.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Gtk::SizeGroup*> property_size_group() ;

/** Current size group the caption is in.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Gtk::SizeGroup*> property_size_group() const;


};

} // namespace Hildon


namespace Glib
{
  /** @relates Hildon::Caption
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Hildon::Caption* wrap(HildonCaption* object, bool take_copy = false);
}
#endif /* _HILDON_WIDGETSMM_CAPTION_H */

