// -*- c++ -*-
// Generated by gtkmmproc -- DO NOT MODIFY!
#ifndef _HILDON_WIDGETSMM_NOTE_H
#define _HILDON_WIDGETSMM_NOTE_H

#include <glibmm.h>

/* $Id: note.hg,v 1.10 2005/02/15 10:52:44 murrayc Exp $ */

/* note.h
 *
 * Copyright (C) 1998-2005 The gtkmm Development Team
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the Free
 * Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <gtkmm/dialog.h>
#include <gtkmm/progressbar.h>


#ifndef DOXYGEN_SHOULD_SKIP_THIS
typedef struct _HildonNote HildonNote;
typedef struct _HildonNoteClass HildonNoteClass;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{ class Note_Class; } // namespace Hildon
namespace Hildon
{

/** @addtogroup hildon_widgetsmmEnums Enums and Flags */

/**
 * @ingroup hildon_widgetsmmEnums
 */
enum NoteType
{
  NOTE_CONFIRMATION_TYPE,
  NOTE_CONFIRMATION_BUTTON_TYPE,
  NOTE_INFORMATION_TYPE,
  NOTE_INFORMATION_THEME_TYPE,
  NOTE_PROGRESSBAR_TYPE
};

} // namespace Hildon


#ifndef DOXYGEN_SHOULD_SKIP_THIS
namespace Glib
{

template <>
class Value<Hildon::NoteType> : public Glib::Value_Enum<Hildon::NoteType>
{
public:
  static GType value_type() G_GNUC_CONST;
};

} // namespace Glib
#endif /* DOXYGEN_SHOULD_SKIP_THIS */


namespace Hildon
{


/**
 *
 * @ingroup Dialogs
 */

class Note : public Gtk::Dialog
{
  public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  typedef Note CppObjectType;
  typedef Note_Class CppClassType;
  typedef HildonNote BaseObjectType;
  typedef HildonNoteClass BaseClassType;
#endif /* DOXYGEN_SHOULD_SKIP_THIS */

  virtual ~Note();

#ifndef DOXYGEN_SHOULD_SKIP_THIS

private:
  friend class Note_Class;
  static CppClassType note_class_;

  // noncopyable
  Note(const Note&);
  Note& operator=(const Note&);

protected:
  explicit Note(const Glib::ConstructParams& construct_params);
  explicit Note(HildonNote* castitem);

#endif /* DOXYGEN_SHOULD_SKIP_THIS */

public:
#ifndef DOXYGEN_SHOULD_SKIP_THIS
  static GType get_type()      G_GNUC_CONST;
  static GType get_base_type() G_GNUC_CONST;
#endif

  ///Provides access to the underlying C GtkObject.
  HildonNote*       gobj()       { return reinterpret_cast<HildonNote*>(gobject_); }

  ///Provides access to the underlying C GtkObject.
  const HildonNote* gobj() const { return reinterpret_cast<HildonNote*>(gobject_); }


public:
  //C++ methods used to invoke GTK+ virtual functions:

protected:
  //GTK+ Virtual Functions (override these to change behaviour):

  //Default Signal Handlers::


private:

  
public:
  Note();

  explicit Note(Gtk::Window& parent, const Glib::ustring& description);

  explicit Note(Gtk::Window& parent, const Glib::ustring& description, const Gtk::StockID& stock_id);
  explicit Note(const Glib::ustring& description, const Gtk::StockID& stock_id = Gtk::StockID());

  Note(NoteType note_type, Gtk::Window& parent, const Glib::ustring& description = Glib::ustring(), const Gtk::StockID& stock_id = Gtk::StockID());
  explicit Note(NoteType note_type, const Glib::ustring& description = Glib::ustring(), const Gtk::StockID& stock_id = Gtk::StockID());

  //Creates a "cancel" dialog:
  Note(const Glib::ustring& description, const Gtk::StockID& stock_id, const Gtk::ProgressBar& progress_bar);
  

  /** Sets the button text to be used by the hildon_note widget.
   * @param text Sets the button text and if there is two buttons in dialog, 
   * the button texts will be &lt;text&gt;, "Cancel".
   */
  void set_button_text(const Glib::ustring& text);

  
  /** Sets the button texts to be used by this hildon_note widget.
   * @param textOk The new text of the default OK button.
   * @param textCancel The new text of the default cancel button.
   */
  void set_button_text(const Glib::ustring& textOk, const Glib::ustring& textCancel);

  /** The type of the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<NoteType> property_note_type() ;

/** The type of the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<NoteType> property_note_type() const;

  /** The text that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Glib::ustring> property_description() ;

/** The text that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Glib::ustring> property_description() const;

  /** The name of the icon that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Gtk::StockID> property_icon() ;

/** The name of the icon that appears in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Gtk::StockID> property_icon() const;

  /** The progressbar that appear in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy<Gtk::ProgressBar*> property_progressbar() ;

/** The progressbar that appear in the note dialog.
   *
   * You rarely need to use properties because there are get_ and set_ methods for almost all of them.
   * @return A PropertyProxy that allows you to get or set the property of the value, or receive notification when
   * the value of the property changes.
   */
  Glib::PropertyProxy_ReadOnly<Gtk::ProgressBar*> property_progressbar() const;


};

} // namespace Hildon


namespace Glib
{
  /** @relates Hildon::Note
   * @param object The C instance
   * @param take_copy False if the result should take ownership of the C instance. True if it should take a new copy or ref.
   * @result A C++ instance that wraps this C instance.
   */
  Hildon::Note* wrap(HildonNote* object, bool take_copy = false);
}
#endif /* _HILDON_WIDGETSMM_NOTE_H */

